
// line 1 "src/main/ragel/FuchakubutsuParser.rl"
/*
 * Copyright 2009 Ilya Epifanov
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


// line 27 "src/main/ragel/FuchakubutsuParser.rl"


package ru.xajile.fuchakubutsu;

public final class Parser extends ParserActions {
  
// line 26 "src/main/java/ru/xajile/fuchakubutsu/Parser.java"
private static byte[] init__fuchakubutsu_actions_0()
{
	return new byte [] {
	    0,    1,    0,    1,    1
	};
}

private static final byte _fuchakubutsu_actions[] = init__fuchakubutsu_actions_0();


private static byte[] init__fuchakubutsu_key_offsets_0()
{
	return new byte [] {
	    0,    1,    3,    5,   15,   25,   27,   29
	};
}

private static final byte _fuchakubutsu_key_offsets[] = init__fuchakubutsu_key_offsets_0();


private static char[] init__fuchakubutsu_trans_keys_0()
{
	return new char [] {
	   40,   40,   91,   40,  126,   40,   46,   95,  126,   48,   59,   65,
	   90,   97,  122,   40,   46,   95,  126,   48,   59,   65,   90,   97,
	  122,   40,   93,   40,   41,   40,    0
	};
}

private static final char _fuchakubutsu_trans_keys[] = init__fuchakubutsu_trans_keys_0();


private static byte[] init__fuchakubutsu_single_lengths_0()
{
	return new byte [] {
	    1,    2,    2,    4,    4,    2,    2,    1
	};
}

private static final byte _fuchakubutsu_single_lengths[] = init__fuchakubutsu_single_lengths_0();


private static byte[] init__fuchakubutsu_range_lengths_0()
{
	return new byte [] {
	    0,    0,    0,    3,    3,    0,    0,    0
	};
}

private static final byte _fuchakubutsu_range_lengths[] = init__fuchakubutsu_range_lengths_0();


private static byte[] init__fuchakubutsu_index_offsets_0()
{
	return new byte [] {
	    0,    2,    5,    8,   16,   24,   27,   30
	};
}

private static final byte _fuchakubutsu_index_offsets[] = init__fuchakubutsu_index_offsets_0();


private static byte[] init__fuchakubutsu_indicies_0()
{
	return new byte [] {
	    1,    0,    1,    2,    0,    1,    3,    0,    1,    4,    4,    5,
	    4,    4,    4,    0,    1,    6,    6,    7,    6,    6,    6,    0,
	    1,    8,    0,    1,    9,    0,   11,   10,    0
	};
}

private static final byte _fuchakubutsu_indicies[] = init__fuchakubutsu_indicies_0();


private static byte[] init__fuchakubutsu_trans_targs_0()
{
	return new byte [] {
	    0,    1,    2,    3,    4,    5,    4,    5,    6,    7,    0,    1
	};
}

private static final byte _fuchakubutsu_trans_targs[] = init__fuchakubutsu_trans_targs_0();


private static byte[] init__fuchakubutsu_trans_actions_0()
{
	return new byte [] {
	    0,    0,    0,    0,    1,    1,    0,    0,    0,    0,    3,    3
	};
}

private static final byte _fuchakubutsu_trans_actions[] = init__fuchakubutsu_trans_actions_0();


private static byte[] init__fuchakubutsu_eof_actions_0()
{
	return new byte [] {
	    0,    0,    0,    0,    0,    0,    0,    3
	};
}

private static final byte _fuchakubutsu_eof_actions[] = init__fuchakubutsu_eof_actions_0();


static final int fuchakubutsu_start = 0;
static final int fuchakubutsu_first_final = 0;
static final int fuchakubutsu_error = -1;

static final int fuchakubutsu_en_main = 0;


// line 33 "src/main/ragel/FuchakubutsuParser.rl"

  public Parser(char[] data, EventHandler handler) {
    super(handler);
    setData(data);
  }

  public boolean parse() {
    int cs = 0;
    int p = 0;
    int pe = data.length;
    int eof = pe;

    
// line 152 "src/main/java/ru/xajile/fuchakubutsu/Parser.java"
	{
	cs = fuchakubutsu_start;
	}

// line 46 "src/main/ragel/FuchakubutsuParser.rl"
    
// line 159 "src/main/java/ru/xajile/fuchakubutsu/Parser.java"
	{
	int _klen;
	int _trans = 0;
	int _acts;
	int _nacts;
	int _keys;
	int _goto_targ = 0;

	_goto: while (true) {
	switch ( _goto_targ ) {
	case 0:
	if ( p == pe ) {
		_goto_targ = 4;
		continue _goto;
	}
case 1:
	_match: do {
	_keys = _fuchakubutsu_key_offsets[cs];
	_trans = _fuchakubutsu_index_offsets[cs];
	_klen = _fuchakubutsu_single_lengths[cs];
	if ( _klen > 0 ) {
		int _lower = _keys;
		int _mid;
		int _upper = _keys + _klen - 1;
		while (true) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( data[p] < _fuchakubutsu_trans_keys[_mid] )
				_upper = _mid - 1;
			else if ( data[p] > _fuchakubutsu_trans_keys[_mid] )
				_lower = _mid + 1;
			else {
				_trans += (_mid - _keys);
				break _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _fuchakubutsu_range_lengths[cs];
	if ( _klen > 0 ) {
		int _lower = _keys;
		int _mid;
		int _upper = _keys + (_klen<<1) - 2;
		while (true) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( data[p] < _fuchakubutsu_trans_keys[_mid] )
				_upper = _mid - 2;
			else if ( data[p] > _fuchakubutsu_trans_keys[_mid+1] )
				_lower = _mid + 2;
			else {
				_trans += ((_mid - _keys)>>1);
				break _match;
			}
		}
		_trans += _klen;
	}
	} while (false);

	_trans = _fuchakubutsu_indicies[_trans];
	cs = _fuchakubutsu_trans_targs[_trans];

	if ( _fuchakubutsu_trans_actions[_trans] != 0 ) {
		_acts = _fuchakubutsu_trans_actions[_trans];
		_nacts = (int) _fuchakubutsu_actions[_acts++];
		while ( _nacts-- > 0 )
	{
			switch ( _fuchakubutsu_actions[_acts++] )
			{
	case 0:
// line 19 "src/main/ragel/FuchakubutsuParser.rl"
	{beginObject(p);}
	break;
	case 1:
// line 20 "src/main/ragel/FuchakubutsuParser.rl"
	{endObject(p);}
	break;
// line 243 "src/main/java/ru/xajile/fuchakubutsu/Parser.java"
			}
		}
	}

case 2:
	if ( ++p != pe ) {
		_goto_targ = 1;
		continue _goto;
	}
case 4:
	if ( p == eof )
	{
	int __acts = _fuchakubutsu_eof_actions[cs];
	int __nacts = (int) _fuchakubutsu_actions[__acts++];
	while ( __nacts-- > 0 ) {
		switch ( _fuchakubutsu_actions[__acts++] ) {
	case 1:
// line 20 "src/main/ragel/FuchakubutsuParser.rl"
	{endObject(p);}
	break;
// line 264 "src/main/java/ru/xajile/fuchakubutsu/Parser.java"
		}
	}
	}

case 5:
	}
	break; }
	}

// line 47 "src/main/ragel/FuchakubutsuParser.rl"

    if (cs < 
// line 277 "src/main/java/ru/xajile/fuchakubutsu/Parser.java"
0
// line 48 "src/main/ragel/FuchakubutsuParser.rl"
) {
      return false;
    }

    eof(p);
    return true;
  }
}
