
// line 1 "src/main/ragel/TsuyujimoParser.rl"
/*
 * Copyright 2009 Ilya Epifanov
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


// line 50 "src/main/ragel/TsuyujimoParser.rl"


package ru.xajile.fuchakubutsu.tsuyujimo;

public final class Parser extends ParserActions {
  
// line 26 "src/main/java/ru/xajile/fuchakubutsu/tsuyujimo/Parser.java"
private static byte[] init__tsuyujimo_actions_0()
{
	return new byte [] {
	    0,    1,    0,    1,    1,    1,    2,    1,    3,    1,    4,    1,
	    5,    1,    6,    1,    7,    1,    8,    1,   10,    1,   12,    1,
	   13,    1,   14,    1,   15,    1,   16,    1,   18,    1,   19,    1,
	   20,    1,   21,    1,   22,    1,   23,    1,   24,    1,   25,    1,
	   26,    1,   27,    1,   28,    2,    0,   17,    2,    9,   10,    2,
	    9,   11,    2,   14,    0,    2,   14,   16,    2,   15,    0,    2,
	   15,   16
	};
}

private static final byte _tsuyujimo_actions[] = init__tsuyujimo_actions_0();


private static short[] init__tsuyujimo_key_offsets_0()
{
	return new short [] {
	    0,    0,    1,    3,   10,   11,   19,   23,   27,   31,   35,   36,
	   38,   40,   42,   44,   45,   47,   49,   50,   52,   54,   55,   56,
	   58,   60,   61,   63,   65,   66,   68,   70,   71,   73,   75,   77,
	   78,   81,   83,   84,   87,   89,   90,   94,   98,  102,  106,  113,
	  114,  115,  116,  117,  120,  123,  124,  133,  142,  151
	};
}

private static final short _tsuyujimo_key_offsets[] = init__tsuyujimo_key_offsets_0();


private static char[] init__tsuyujimo_trans_keys_0()
{
	return new char [] {
	   58,  102,  116,   98,   99,  100,  105,  108,  110,  115,   58,   46,
	   95,   48,   57,   65,   90,   97,  122,   48,   57,   97,  102,   48,
	   57,   97,  102,   48,   57,   97,  102,   48,   57,   97,  102,   58,
	   48,   57,   48,   57,   48,   57,   48,   57,   95,   48,   57,   48,
	   57,   95,   48,   57,   48,   57,   95,   95,   48,   57,   48,   57,
	   95,   48,   57,   48,   57,   95,   48,   57,   48,   57,   95,   48,
	   57,   48,   57,   48,   57,   58,  109,   48,   57,   48,   57,   58,
	  109,   48,   57,   48,   57,   58,   48,   57,   97,  102,   48,   57,
	   97,  102,   48,   57,   97,  102,   48,   57,   97,  102,   98,   99,
	  100,  105,  108,  110,  115,   59,   59,   59,   59,   59,   48,   57,
	   59,   48,   57,   59,   46,   59,   95,   48,   57,   65,   90,   97,
	  122,   46,   59,   95,   48,   57,   65,   90,   97,  122,   46,   59,
	   95,   48,   57,   65,   90,   97,  122,   59,    0
	};
}

private static final char _tsuyujimo_trans_keys[] = init__tsuyujimo_trans_keys_0();


private static byte[] init__tsuyujimo_single_lengths_0()
{
	return new byte [] {
	    0,    1,    2,    7,    1,    2,    0,    0,    0,    0,    1,    0,
	    0,    0,    0,    1,    0,    0,    1,    0,    0,    1,    1,    0,
	    0,    1,    0,    0,    1,    0,    0,    1,    0,    0,    0,    1,
	    1,    0,    1,    1,    0,    1,    0,    0,    0,    0,    7,    1,
	    1,    1,    1,    1,    1,    1,    3,    3,    3,    1
	};
}

private static final byte _tsuyujimo_single_lengths[] = init__tsuyujimo_single_lengths_0();


private static byte[] init__tsuyujimo_range_lengths_0()
{
	return new byte [] {
	    0,    0,    0,    0,    0,    3,    2,    2,    2,    2,    0,    1,
	    1,    1,    1,    0,    1,    1,    0,    1,    1,    0,    0,    1,
	    1,    0,    1,    1,    0,    1,    1,    0,    1,    1,    1,    0,
	    1,    1,    0,    1,    1,    0,    2,    2,    2,    2,    0,    0,
	    0,    0,    0,    1,    1,    0,    3,    3,    3,    0
	};
}

private static final byte _tsuyujimo_range_lengths[] = init__tsuyujimo_range_lengths_0();


private static short[] init__tsuyujimo_index_offsets_0()
{
	return new short [] {
	    0,    0,    2,    5,   13,   15,   21,   24,   27,   30,   33,   35,
	   37,   39,   41,   43,   45,   47,   49,   51,   53,   55,   57,   59,
	   61,   63,   65,   67,   69,   71,   73,   75,   77,   79,   81,   83,
	   85,   88,   90,   92,   95,   97,   99,  102,  105,  108,  111,  119,
	  121,  123,  125,  127,  130,  133,  135,  142,  149,  156
	};
}

private static final short _tsuyujimo_index_offsets[] = init__tsuyujimo_index_offsets_0();


private static byte[] init__tsuyujimo_trans_targs_0()
{
	return new byte [] {
	    2,    0,   47,   57,    0,    1,    4,   10,   35,   38,   53,   41,
	    0,    5,    0,   48,    6,   48,   48,   48,    0,    7,    7,    0,
	    8,    8,    0,    9,    9,    0,   49,   49,    0,   11,    0,   12,
	    0,   13,    0,   14,    0,   15,    0,   16,    0,   17,    0,   18,
	    0,   19,    0,   20,    0,   21,    0,   22,    0,   23,    0,   24,
	    0,   25,    0,   26,    0,   27,    0,   28,    0,   29,    0,   30,
	    0,   31,    0,   32,    0,   33,    0,   34,    0,   50,    0,   36,
	    0,   37,   51,    0,   51,    0,   39,    0,   40,   52,    0,   52,
	    0,   54,    0,   43,   43,    0,   44,   44,    0,   45,   45,    0,
	   56,   56,    0,    1,    4,   10,   35,   38,   53,   41,    0,    3,
	    0,    3,    0,    3,    0,    3,    0,    3,   51,    0,    3,   52,
	    0,    3,    0,   55,    3,   42,   55,   55,   55,    0,   55,    3,
	   42,   55,   55,   55,    0,   55,    3,   42,   55,   55,   55,    0,
	    3,    0,    0
	};
}

private static final byte _tsuyujimo_trans_targs[] = init__tsuyujimo_trans_targs_0();


private static byte[] init__tsuyujimo_trans_actions_0()
{
	return new byte [] {
	    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,   53,    0,   53,   53,   53,    0,    3,    5,    0,
	    7,    9,    0,   11,   13,    0,   15,   17,    0,    0,    0,   56,
	    0,   19,    0,   19,    0,   19,    0,   39,    0,   56,    0,   19,
	    0,   41,    0,   56,    0,   19,    0,   43,    0,    0,    0,   56,
	    0,   19,    0,   45,    0,   56,    0,   19,    0,   47,    0,   56,
	    0,   19,    0,   49,    0,   56,    0,   19,    0,   19,    0,    0,
	    0,   59,   56,    0,   19,    0,    0,    0,   59,   56,    0,   19,
	    0,    0,    0,    3,    5,    0,    7,    9,    0,   11,   13,    0,
	   15,   17,    0,    0,    0,    0,    0,    0,    0,    0,    0,   35,
	    0,    0,    0,   31,    0,   51,    0,   21,   19,    0,   23,   19,
	    0,   37,    0,   68,   71,   27,   68,   68,   68,    0,    1,   29,
	    0,    1,    1,    1,    0,   62,   65,   25,   62,   62,   62,    0,
	   33,    0,    0
	};
}

private static final byte _tsuyujimo_trans_actions[] = init__tsuyujimo_trans_actions_0();


private static byte[] init__tsuyujimo_eof_actions_0()
{
	return new byte [] {
	    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
	    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,   35,
	    0,   31,   51,   21,   23,   37,   71,   29,   65,   33
	};
}

private static final byte _tsuyujimo_eof_actions[] = init__tsuyujimo_eof_actions_0();


static final int tsuyujimo_start = 46;
static final int tsuyujimo_first_final = 46;
static final int tsuyujimo_error = 0;

static final int tsuyujimo_en_main = 46;


// line 56 "src/main/ragel/TsuyujimoParser.rl"

  public Parser(char[] data, int off, int len, EventHandler handler) {
    super(handler);
    setData(data, off, len);
  }

  public Parser(char[] data, EventHandler handler) {
    this(data, 0, data.length, handler);
  }

  public boolean parse() {
    int cs = 0;
    int p = off;
    int pe = off + len;
    int eof = pe;

    
// line 206 "src/main/java/ru/xajile/fuchakubutsu/tsuyujimo/Parser.java"
	{
	cs = tsuyujimo_start;
	}

// line 73 "src/main/ragel/TsuyujimoParser.rl"
    
// line 213 "src/main/java/ru/xajile/fuchakubutsu/tsuyujimo/Parser.java"
	{
	int _klen;
	int _trans = 0;
	int _acts;
	int _nacts;
	int _keys;
	int _goto_targ = 0;

	_goto: while (true) {
	switch ( _goto_targ ) {
	case 0:
	if ( p == pe ) {
		_goto_targ = 4;
		continue _goto;
	}
	if ( cs == 0 ) {
		_goto_targ = 5;
		continue _goto;
	}
case 1:
	_match: do {
	_keys = _tsuyujimo_key_offsets[cs];
	_trans = _tsuyujimo_index_offsets[cs];
	_klen = _tsuyujimo_single_lengths[cs];
	if ( _klen > 0 ) {
		int _lower = _keys;
		int _mid;
		int _upper = _keys + _klen - 1;
		while (true) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( data[p] < _tsuyujimo_trans_keys[_mid] )
				_upper = _mid - 1;
			else if ( data[p] > _tsuyujimo_trans_keys[_mid] )
				_lower = _mid + 1;
			else {
				_trans += (_mid - _keys);
				break _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _tsuyujimo_range_lengths[cs];
	if ( _klen > 0 ) {
		int _lower = _keys;
		int _mid;
		int _upper = _keys + (_klen<<1) - 2;
		while (true) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( data[p] < _tsuyujimo_trans_keys[_mid] )
				_upper = _mid - 2;
			else if ( data[p] > _tsuyujimo_trans_keys[_mid+1] )
				_lower = _mid + 2;
			else {
				_trans += ((_mid - _keys)>>1);
				break _match;
			}
		}
		_trans += _klen;
	}
	} while (false);

	cs = _tsuyujimo_trans_targs[_trans];

	if ( _tsuyujimo_trans_actions[_trans] != 0 ) {
		_acts = _tsuyujimo_trans_actions[_trans];
		_nacts = (int) _tsuyujimo_actions[_acts++];
		while ( _nacts-- > 0 )
	{
			switch ( _tsuyujimo_actions[_acts++] )
			{
	case 0:
// line 19 "src/main/ragel/TsuyujimoParser.rl"
	{finishCharInString(p);}
	break;
	case 1:
// line 20 "src/main/ragel/TsuyujimoParser.rl"
	{h1(data[p]);}
	break;
	case 2:
// line 20 "src/main/ragel/TsuyujimoParser.rl"
	{h1h(data[p]);}
	break;
	case 3:
// line 21 "src/main/ragel/TsuyujimoParser.rl"
	{h2(data[p]);}
	break;
	case 4:
// line 21 "src/main/ragel/TsuyujimoParser.rl"
	{h2h(data[p]);}
	break;
	case 5:
// line 22 "src/main/ragel/TsuyujimoParser.rl"
	{h3(data[p]);}
	break;
	case 6:
// line 22 "src/main/ragel/TsuyujimoParser.rl"
	{h3h(data[p]);}
	break;
	case 7:
// line 23 "src/main/ragel/TsuyujimoParser.rl"
	{h4(data[p]);}
	break;
	case 8:
// line 23 "src/main/ragel/TsuyujimoParser.rl"
	{h4h(data[p]);}
	break;
	case 9:
// line 25 "src/main/ragel/TsuyujimoParser.rl"
	{initNumeric();}
	break;
	case 10:
// line 26 "src/main/ragel/TsuyujimoParser.rl"
	{addUpNumeric(data[p] - '0');}
	break;
	case 11:
// line 28 "src/main/ragel/TsuyujimoParser.rl"
	{negativeNumeric();}
	break;
	case 12:
// line 30 "src/main/ragel/TsuyujimoParser.rl"
	{finishInt();}
	break;
	case 13:
// line 31 "src/main/ragel/TsuyujimoParser.rl"
	{finishLong();}
	break;
	case 14:
// line 33 "src/main/ragel/TsuyujimoParser.rl"
	{finishEncodedCharInString(p);}
	break;
	case 15:
// line 34 "src/main/ragel/TsuyujimoParser.rl"
	{initString(p);}
	break;
	case 16:
// line 34 "src/main/ragel/TsuyujimoParser.rl"
	{finishString(p);}
	break;
	case 17:
// line 35 "src/main/ragel/TsuyujimoParser.rl"
	{finishChar(data[p]);}
	break;
	case 18:
// line 35 "src/main/ragel/TsuyujimoParser.rl"
	{finishEncodedChar();}
	break;
	case 19:
// line 36 "src/main/ragel/TsuyujimoParser.rl"
	{finishBoolTrue();}
	break;
	case 20:
// line 36 "src/main/ragel/TsuyujimoParser.rl"
	{finishBoolFalse();}
	break;
	case 21:
// line 37 "src/main/ragel/TsuyujimoParser.rl"
	{finishNull();}
	break;
	case 22:
// line 42 "src/main/ragel/TsuyujimoParser.rl"
	{dateYear();}
	break;
	case 23:
// line 42 "src/main/ragel/TsuyujimoParser.rl"
	{dateMonth();}
	break;
	case 24:
// line 42 "src/main/ragel/TsuyujimoParser.rl"
	{dateDay();}
	break;
	case 25:
// line 43 "src/main/ragel/TsuyujimoParser.rl"
	{dateHour();}
	break;
	case 26:
// line 43 "src/main/ragel/TsuyujimoParser.rl"
	{dateMinutes();}
	break;
	case 27:
// line 44 "src/main/ragel/TsuyujimoParser.rl"
	{dateSeconds();}
	break;
	case 28:
// line 44 "src/main/ragel/TsuyujimoParser.rl"
	{finishDateWithMillis();}
	break;
// line 408 "src/main/java/ru/xajile/fuchakubutsu/tsuyujimo/Parser.java"
			}
		}
	}

case 2:
	if ( cs == 0 ) {
		_goto_targ = 5;
		continue _goto;
	}
	if ( ++p != pe ) {
		_goto_targ = 1;
		continue _goto;
	}
case 4:
	if ( p == eof )
	{
	int __acts = _tsuyujimo_eof_actions[cs];
	int __nacts = (int) _tsuyujimo_actions[__acts++];
	while ( __nacts-- > 0 ) {
		switch ( _tsuyujimo_actions[__acts++] ) {
	case 12:
// line 30 "src/main/ragel/TsuyujimoParser.rl"
	{finishInt();}
	break;
	case 13:
// line 31 "src/main/ragel/TsuyujimoParser.rl"
	{finishLong();}
	break;
	case 14:
// line 33 "src/main/ragel/TsuyujimoParser.rl"
	{finishEncodedCharInString(p);}
	break;
	case 15:
// line 34 "src/main/ragel/TsuyujimoParser.rl"
	{initString(p);}
	break;
	case 16:
// line 34 "src/main/ragel/TsuyujimoParser.rl"
	{finishString(p);}
	break;
	case 18:
// line 35 "src/main/ragel/TsuyujimoParser.rl"
	{finishEncodedChar();}
	break;
	case 19:
// line 36 "src/main/ragel/TsuyujimoParser.rl"
	{finishBoolTrue();}
	break;
	case 20:
// line 36 "src/main/ragel/TsuyujimoParser.rl"
	{finishBoolFalse();}
	break;
	case 21:
// line 37 "src/main/ragel/TsuyujimoParser.rl"
	{finishNull();}
	break;
	case 28:
// line 44 "src/main/ragel/TsuyujimoParser.rl"
	{finishDateWithMillis();}
	break;
// line 469 "src/main/java/ru/xajile/fuchakubutsu/tsuyujimo/Parser.java"
		}
	}
	}

case 5:
	}
	break; }
	}

// line 74 "src/main/ragel/TsuyujimoParser.rl"

    return (cs >= 
// line 482 "src/main/java/ru/xajile/fuchakubutsu/tsuyujimo/Parser.java"
46
// line 75 "src/main/ragel/TsuyujimoParser.rl"
);
  }
}
